Require Import ImplemProgramWithMap.
Import P.

Module java_lang_ObjectType.

    Definition name : ClassName := (javaLang, 1%positive). 

End java_lang_ObjectType.

Module java_lang_ObjectSignature.
    Import java_lang_ObjectType.

    Definition _init_TShort : ShortMethodSignature := METHODSIGNATURE.Build_t
      (12%positive)
      nil
      None
    .
    Definition _init_T : MethodSignature := (name, _init_TShort).

End java_lang_ObjectSignature.

Module java_lang_Object.

    Definition _init_TInstructions :  MapN.t (Instruction*option PC) :=
      (bc_single 0%N (Return))
    .

    Definition _init_TBody : BytecodeMethod := BYTECODEMETHOD.Build_t
      0%N
      _init_TInstructions
      nil
      1
      0
    .

    Definition _init_T : Method := METHOD.Build_t
      java_lang_ObjectSignature._init_TShort
      (Some _init_TBody)
      false
      false
      false
      Public
    .

    Definition class : Class := CLASS.Build_t
      java_lang_ObjectType.name
      None (* (Some java_lang_Object.className) *)
      nil
      mf_empty
      (ms_single _init_T)
      false
      true
      false
    .

End java_lang_Object.
