Require Import ImplemProgramWithMap.
Require Import Map_java_lang_Object.
Require Import Map_java_lang_Exception.
Import P.

Module java_lang_RuntimeExceptionType.

    Definition name : ClassName := (javaLang, RuntimeException). (* 3 *) 

End java_lang_RuntimeExceptionType.

Module java_lang_RuntimeExceptionSignature.
    Import java_lang_RuntimeExceptionType.
    Definition _init_Short : ShortMethodSignature := METHODSIGNATURE.Build_t
      (10%positive)
      nil
      None
    .
    Definition _init_ : MethodSignature := (name, _init_Short).

End java_lang_RuntimeExceptionSignature.

Module java_lang_RuntimeException.

    Definition _init_Instructions :  MapN.t (Instruction*option PC) :=
      (bc_cons 0%N (Vload Aval 0%N) 1%N 
      (bc_cons 1%N (Invokespecial java_lang_ExceptionSignature._init_) 4%N 
      (bc_single 4%N (Return))))
    .

    Definition _init_Body : BytecodeMethod := BYTECODEMETHOD.Build_t
      0%N
      _init_Instructions
      nil
      1
      1
    .

    Definition _init_ : Method := METHOD.Build_t
      java_lang_RuntimeExceptionSignature._init_Short
      (Some _init_Body)
      false
      false
      false
      Public
    .

    Definition class : Class := CLASS.Build_t
      java_lang_RuntimeExceptionType.name
      (Some java_lang_ExceptionType.name)
      nil
      mf_empty
      (ms_single _init_)
      false
      true
      false
    .

 End java_lang_RuntimeException.
