  Module java_lang_Object.

    Definition className : ClassName := (javaLang, object). 


    (* method signature *)

    Definition _init_Signature : ShortMethodSignature :=
      METHODSIGNATURE.Build_t
      (10%positive)          (** method name **)
      nil                               (** parameters : list type **)
      None                              (** result : option type **)
    .


    (* method Object() *)

    Definition _init_Instructions : list (PC*Instruction) :=
      (0%N, Return)::
      nil
    .

    Definition _init_Body : BytecodeMethod := BYTECODEMETHOD.Build_t
      _init_Instructions
      nil                               (** ExceptionHandlers **)
      1                                 (** max_locals **)
      0                                 (** max_operand_stack_size **)
    .

    Definition _init_Method : Method := METHOD.Build_t
      _init_Signature
      (Some _init_Body)
      false                             (** isFinal **)
      false                             (** isStatic **)
      false                             (** isNative **)
      Public                            (** visibility **)
    .

    Definition class : Class := CLASS.Build_t
      className
      None (* (Some java_lang_Object.className) *)
                                        (** superClass name **)
      nil                               (** list of implemented interfaces **)
      nil                               (** list of fields **)
      (_init_Method::nil)               (** list of methods **)
      false                             (** isFinal **)
      true                              (** isPublic **)
      false                             (** isAbstract **)
    .

  End java_lang_Object.
    
