Require Import ImplemProgramWithList.
Require Import List_java_lang_Object.
Require Import List_java_lang_Throwable.
Require Import List_java_lang_Exception.
Import P.

Module TheProgram.

  Definition java_util_Iterator_interfaceName : InterfaceName := (EmptyPackageName, 11%positive). 
  Definition java_util_ListIterator_interfaceName : InterfaceName := (EmptyPackageName, 11%positive). 
  Definition java_lang_Iterable_interfaceName : InterfaceName := (EmptyPackageName, 11%positive). 
  Definition java_util_Collection_interfaceName : InterfaceName := (EmptyPackageName, 11%positive). 
  Definition java_util_List_interfaceName : InterfaceName := (EmptyPackageName, 11%positive). 

  Module java_util_Iterator.

    Definition interfaceName : InterfaceName := java_util_Iterator_interfaceName.

    Definition hasNextShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (10%positive)
      nil
      (Some (PrimitiveType BOOLEAN))
    .
    Definition hasNextSignature : MethodSignature := (interfaceName, hasNextShortSignature).


    Definition nextShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (11%positive)
      nil
      (Some (ReferenceType (ClassType java_lang_Object_className)))
    .
    Definition nextSignature : MethodSignature := (interfaceName, nextShortSignature).


    Definition removeShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (12%positive)
      nil
      None
    .
    Definition removeSignature : MethodSignature := (interfaceName, removeShortSignature).


    Definition hasNextMethod : Method := METHOD.Build_t
      hasNextShortSignature
      None
      false
      false
      false
      Public
    .

    Definition nextMethod : Method := METHOD.Build_t
      nextShortSignature
      None
      false
      false
      false
      Public
    .

    Definition removeMethod : Method := METHOD.Build_t
      removeShortSignature
      None
      false
      false
      false
      Public
    .

    Definition interface : Interface := INTERFACE.Build_t
      interfaceName
      nil
      nil
      (hasNextMethod :: nextMethod :: removeMethod :: nil)
      false
      true
      true
    .

  End java_util_Iterator.

  Module java_util_ListIterator.

    Definition interfaceName : InterfaceName := java_util_ListIterator_interfaceName.

    Definition hasNextShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (10%positive)
      nil
      (Some (PrimitiveType BOOLEAN))
    .
    Definition hasNextSignature : MethodSignature := (interfaceName, hasNextShortSignature).


    Definition nextShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (11%positive)
      nil
      (Some (ReferenceType (ClassType java_lang_Object_className)))
    .
    Definition nextSignature : MethodSignature := (interfaceName, nextShortSignature).


    Definition hasPreviousShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (12%positive)
      nil
      (Some (PrimitiveType BOOLEAN))
    .
    Definition hasPreviousSignature : MethodSignature := (interfaceName, hasPreviousShortSignature).


    Definition previousShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (13%positive)
      nil
      (Some (ReferenceType (ClassType java_lang_Object_className)))
    .
    Definition previousSignature : MethodSignature := (interfaceName, previousShortSignature).


    Definition nextIndexShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (14%positive)
      nil
      (Some (PrimitiveType INT))
    .
    Definition nextIndexSignature : MethodSignature := (interfaceName, nextIndexShortSignature).


    Definition previousIndexShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (15%positive)
      nil
      (Some (PrimitiveType INT))
    .
    Definition previousIndexSignature : MethodSignature := (interfaceName, previousIndexShortSignature).


    Definition removeShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (16%positive)
      nil
      None
    .
    Definition removeSignature : MethodSignature := (interfaceName, removeShortSignature).


    Definition setShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (17%positive)
      ((ReferenceType (ClassType java_lang_Object_className))::nil)
      None
    .
    Definition setSignature : MethodSignature := (interfaceName, setShortSignature).


    Definition addShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (18%positive)
      ((ReferenceType (ClassType java_lang_Object_className))::nil)
      None
    .
    Definition addSignature : MethodSignature := (interfaceName, addShortSignature).


    Definition hasNextMethod : Method := METHOD.Build_t
      hasNextShortSignature
      None
      false
      false
      false
      Public
    .

    Definition nextMethod : Method := METHOD.Build_t
      nextShortSignature
      None
      false
      false
      false
      Public
    .

    Definition hasPreviousMethod : Method := METHOD.Build_t
      hasPreviousShortSignature
      None
      false
      false
      false
      Public
    .

    Definition previousMethod : Method := METHOD.Build_t
      previousShortSignature
      None
      false
      false
      false
      Public
    .

    Definition nextIndexMethod : Method := METHOD.Build_t
      nextIndexShortSignature
      None
      false
      false
      false
      Public
    .

    Definition previousIndexMethod : Method := METHOD.Build_t
      previousIndexShortSignature
      None
      false
      false
      false
      Public
    .

    Definition removeMethod : Method := METHOD.Build_t
      removeShortSignature
      None
      false
      false
      false
      Public
    .

    Definition setMethod : Method := METHOD.Build_t
      setShortSignature
      None
      false
      false
      false
      Public
    .

    Definition addMethod : Method := METHOD.Build_t
      addShortSignature
      None
      false
      false
      false
      Public
    .

    Definition interface : Interface := INTERFACE.Build_t
      interfaceName
      (java_util_Iterator_interfaceName ::nil)
      nil
      (hasNextMethod :: nextMethod :: hasPreviousMethod :: previousMethod :: nextIndexMethod :: previousIndexMethod :: removeMethod :: setMethod :: addMethod :: nil)
      false
      true
      true
    .

  End java_util_ListIterator.

  Module java_lang_Iterable.

    Definition interfaceName : InterfaceName := java_lang_Iterable_interfaceName.

    Definition iteratorShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (10%positive)
      nil
      (Some (ReferenceType (InterfaceType java_util_Iterator_interfaceName)))
    .
    Definition iteratorSignature : MethodSignature := (interfaceName, iteratorShortSignature).


    Definition iteratorMethod : Method := METHOD.Build_t
      iteratorShortSignature
      None
      false
      false
      false
      Public
    .

    Definition interface : Interface := INTERFACE.Build_t
      interfaceName
      nil
      nil
      (iteratorMethod :: nil)
      false
      true
      true
    .

  End java_lang_Iterable.

  Module java_util_Collection.

    Definition interfaceName : InterfaceName := java_util_Collection_interfaceName.

    Definition sizeShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (10%positive)
      nil
      (Some (PrimitiveType INT))
    .
    Definition sizeSignature : MethodSignature := (interfaceName, sizeShortSignature).


    Definition isEmptyShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (11%positive)
      nil
      (Some (PrimitiveType BOOLEAN))
    .
    Definition isEmptySignature : MethodSignature := (interfaceName, isEmptyShortSignature).


    Definition containsShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (12%positive)
      ((ReferenceType (ClassType java_lang_Object_className))::nil)
      (Some (PrimitiveType BOOLEAN))
    .
    Definition containsSignature : MethodSignature := (interfaceName, containsShortSignature).


    Definition iteratorShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (13%positive)
      nil
      (Some (ReferenceType (InterfaceType java_util_Iterator_interfaceName)))
    .
    Definition iteratorSignature : MethodSignature := (interfaceName, iteratorShortSignature).


    Definition toArrayShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (14%positive)
      nil
      (Some (ReferenceType (ArrayType (ReferenceType (ClassType java_lang_Object_className)))))
    .
    Definition toArraySignature : MethodSignature := (interfaceName, toArrayShortSignature).


    Definition toArray1ShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (15%positive)
      ((ReferenceType (ArrayType (ReferenceType (ClassType java_lang_Object_className))))::nil)
      (Some (ReferenceType (ArrayType (ReferenceType (ClassType java_lang_Object_className)))))
    .
    Definition toArray1Signature : MethodSignature := (interfaceName, toArray1ShortSignature).


    Definition add1ShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (16%positive)
      ((ReferenceType (ClassType java_lang_Object_className))::nil)
      (Some (PrimitiveType BOOLEAN))
    .
    Definition add1Signature : MethodSignature := (interfaceName, add1ShortSignature).


    Definition remove1ShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (17%positive)
      ((ReferenceType (ClassType java_lang_Object_className))::nil)
      (Some (PrimitiveType BOOLEAN))
    .
    Definition remove1Signature : MethodSignature := (interfaceName, remove1ShortSignature).


    Definition containsAllShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (18%positive)
      ((ReferenceType (InterfaceType java_util_Collection_interfaceName))::nil)
      (Some (PrimitiveType BOOLEAN))
    .
    Definition containsAllSignature : MethodSignature := (interfaceName, containsAllShortSignature).


    Definition addAllShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (19%positive)
      ((ReferenceType (InterfaceType java_util_Collection_interfaceName))::nil)
      (Some (PrimitiveType BOOLEAN))
    .
    Definition addAllSignature : MethodSignature := (interfaceName, addAllShortSignature).


    Definition removeAllShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (20%positive)
      ((ReferenceType (InterfaceType java_util_Collection_interfaceName))::nil)
      (Some (PrimitiveType BOOLEAN))
    .
    Definition removeAllSignature : MethodSignature := (interfaceName, removeAllShortSignature).


    Definition retainAllShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (21%positive)
      ((ReferenceType (InterfaceType java_util_Collection_interfaceName))::nil)
      (Some (PrimitiveType BOOLEAN))
    .
    Definition retainAllSignature : MethodSignature := (interfaceName, retainAllShortSignature).


    Definition clearShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (22%positive)
      nil
      None
    .
    Definition clearSignature : MethodSignature := (interfaceName, clearShortSignature).


    Definition equalsShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (23%positive)
      ((ReferenceType (ClassType java_lang_Object_className))::nil)
      (Some (PrimitiveType BOOLEAN))
    .
    Definition equalsSignature : MethodSignature := (interfaceName, equalsShortSignature).


    Definition hashCodeShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (24%positive)
      nil
      (Some (PrimitiveType INT))
    .
    Definition hashCodeSignature : MethodSignature := (interfaceName, hashCodeShortSignature).


    Definition sizeMethod : Method := METHOD.Build_t
      sizeShortSignature
      None
      false
      false
      false
      Public
    .

    Definition isEmptyMethod : Method := METHOD.Build_t
      isEmptyShortSignature
      None
      false
      false
      false
      Public
    .

    Definition containsMethod : Method := METHOD.Build_t
      containsShortSignature
      None
      false
      false
      false
      Public
    .

    Definition iteratorMethod : Method := METHOD.Build_t
      iteratorShortSignature
      None
      false
      false
      false
      Public
    .

    Definition toArrayMethod : Method := METHOD.Build_t
      toArrayShortSignature
      None
      false
      false
      false
      Public
    .

    Definition toArray1Method : Method := METHOD.Build_t
      toArray1ShortSignature
      None
      false
      false
      false
      Public
    .

    Definition add1Method : Method := METHOD.Build_t
      add1ShortSignature
      None
      false
      false
      false
      Public
    .

    Definition remove1Method : Method := METHOD.Build_t
      remove1ShortSignature
      None
      false
      false
      false
      Public
    .

    Definition containsAllMethod : Method := METHOD.Build_t
      containsAllShortSignature
      None
      false
      false
      false
      Public
    .

    Definition addAllMethod : Method := METHOD.Build_t
      addAllShortSignature
      None
      false
      false
      false
      Public
    .

    Definition removeAllMethod : Method := METHOD.Build_t
      removeAllShortSignature
      None
      false
      false
      false
      Public
    .

    Definition retainAllMethod : Method := METHOD.Build_t
      retainAllShortSignature
      None
      false
      false
      false
      Public
    .

    Definition clearMethod : Method := METHOD.Build_t
      clearShortSignature
      None
      false
      false
      false
      Public
    .

    Definition equalsMethod : Method := METHOD.Build_t
      equalsShortSignature
      None
      false
      false
      false
      Public
    .

    Definition hashCodeMethod : Method := METHOD.Build_t
      hashCodeShortSignature
      None
      false
      false
      false
      Public
    .

    Definition interface : Interface := INTERFACE.Build_t
      interfaceName
      (java_lang_Iterable_interfaceName ::nil)
      nil
      (sizeMethod :: isEmptyMethod :: containsMethod :: iteratorMethod :: toArrayMethod :: toArray1Method :: add1Method :: remove1Method :: containsAllMethod :: addAllMethod :: removeAllMethod :: retainAllMethod :: clearMethod :: equalsMethod :: hashCodeMethod :: nil)
      false
      true
      true
    .

  End java_util_Collection.

  Module java_util_List.

    Definition interfaceName : InterfaceName := java_util_List_interfaceName.

    Definition sizeShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (10%positive)
      nil
      (Some (PrimitiveType INT))
    .
    Definition sizeSignature : MethodSignature := (interfaceName, sizeShortSignature).


    Definition isEmptyShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (11%positive)
      nil
      (Some (PrimitiveType BOOLEAN))
    .
    Definition isEmptySignature : MethodSignature := (interfaceName, isEmptyShortSignature).


    Definition containsShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (12%positive)
      ((ReferenceType (ClassType java_lang_Object_className))::nil)
      (Some (PrimitiveType BOOLEAN))
    .
    Definition containsSignature : MethodSignature := (interfaceName, containsShortSignature).


    Definition iteratorShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (13%positive)
      nil
      (Some (ReferenceType (InterfaceType java_util_Iterator_interfaceName)))
    .
    Definition iteratorSignature : MethodSignature := (interfaceName, iteratorShortSignature).


    Definition toArrayShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (14%positive)
      nil
      (Some (ReferenceType (ArrayType (ReferenceType (ClassType java_lang_Object_className)))))
    .
    Definition toArraySignature : MethodSignature := (interfaceName, toArrayShortSignature).


    Definition toArray1ShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (15%positive)
      ((ReferenceType (ArrayType (ReferenceType (ClassType java_lang_Object_className))))::nil)
      (Some (ReferenceType (ArrayType (ReferenceType (ClassType java_lang_Object_className)))))
    .
    Definition toArray1Signature : MethodSignature := (interfaceName, toArray1ShortSignature).


    Definition add1ShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (16%positive)
      ((ReferenceType (ClassType java_lang_Object_className))::nil)
      (Some (PrimitiveType BOOLEAN))
    .
    Definition add1Signature : MethodSignature := (interfaceName, add1ShortSignature).


    Definition remove1ShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (17%positive)
      ((ReferenceType (ClassType java_lang_Object_className))::nil)
      (Some (PrimitiveType BOOLEAN))
    .
    Definition remove1Signature : MethodSignature := (interfaceName, remove1ShortSignature).


    Definition containsAllShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (18%positive)
      ((ReferenceType (InterfaceType java_util_Collection_interfaceName))::nil)
      (Some (PrimitiveType BOOLEAN))
    .
    Definition containsAllSignature : MethodSignature := (interfaceName, containsAllShortSignature).


    Definition addAllShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (19%positive)
      ((ReferenceType (InterfaceType java_util_Collection_interfaceName))::nil)
      (Some (PrimitiveType BOOLEAN))
    .
    Definition addAllSignature : MethodSignature := (interfaceName, addAllShortSignature).


    Definition addAll1ShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (20%positive)
      ((PrimitiveType INT)::(ReferenceType (InterfaceType java_util_Collection_interfaceName))::nil)
      (Some (PrimitiveType BOOLEAN))
    .
    Definition addAll1Signature : MethodSignature := (interfaceName, addAll1ShortSignature).


    Definition removeAllShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (21%positive)
      ((ReferenceType (InterfaceType java_util_Collection_interfaceName))::nil)
      (Some (PrimitiveType BOOLEAN))
    .
    Definition removeAllSignature : MethodSignature := (interfaceName, removeAllShortSignature).


    Definition retainAllShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (22%positive)
      ((ReferenceType (InterfaceType java_util_Collection_interfaceName))::nil)
      (Some (PrimitiveType BOOLEAN))
    .
    Definition retainAllSignature : MethodSignature := (interfaceName, retainAllShortSignature).


    Definition clearShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (23%positive)
      nil
      None
    .
    Definition clearSignature : MethodSignature := (interfaceName, clearShortSignature).


    Definition equalsShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (24%positive)
      ((ReferenceType (ClassType java_lang_Object_className))::nil)
      (Some (PrimitiveType BOOLEAN))
    .
    Definition equalsSignature : MethodSignature := (interfaceName, equalsShortSignature).


    Definition hashCodeShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (25%positive)
      nil
      (Some (PrimitiveType INT))
    .
    Definition hashCodeSignature : MethodSignature := (interfaceName, hashCodeShortSignature).


    Definition getShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (26%positive)
      ((PrimitiveType INT)::nil)
      (Some (ReferenceType (ClassType java_lang_Object_className)))
    .
    Definition getSignature : MethodSignature := (interfaceName, getShortSignature).


    Definition set1ShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (27%positive)
      ((PrimitiveType INT)::(ReferenceType (ClassType java_lang_Object_className))::nil)
      (Some (ReferenceType (ClassType java_lang_Object_className)))
    .
    Definition set1Signature : MethodSignature := (interfaceName, set1ShortSignature).


    Definition add2ShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (28%positive)
      ((PrimitiveType INT)::(ReferenceType (ClassType java_lang_Object_className))::nil)
      None
    .
    Definition add2Signature : MethodSignature := (interfaceName, add2ShortSignature).


    Definition remove2ShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (29%positive)
      ((PrimitiveType INT)::nil)
      (Some (ReferenceType (ClassType java_lang_Object_className)))
    .
    Definition remove2Signature : MethodSignature := (interfaceName, remove2ShortSignature).


    Definition indexOfShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (30%positive)
      ((ReferenceType (ClassType java_lang_Object_className))::nil)
      (Some (PrimitiveType INT))
    .
    Definition indexOfSignature : MethodSignature := (interfaceName, indexOfShortSignature).


    Definition lastIndexOfShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (31%positive)
      ((ReferenceType (ClassType java_lang_Object_className))::nil)
      (Some (PrimitiveType INT))
    .
    Definition lastIndexOfSignature : MethodSignature := (interfaceName, lastIndexOfShortSignature).


    Definition listIteratorShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (32%positive)
      nil
      (Some (ReferenceType (InterfaceType java_util_ListIterator_interfaceName)))
    .
    Definition listIteratorSignature : MethodSignature := (interfaceName, listIteratorShortSignature).


    Definition listIterator1ShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (33%positive)
      ((PrimitiveType INT)::nil)
      (Some (ReferenceType (InterfaceType java_util_ListIterator_interfaceName)))
    .
    Definition listIterator1Signature : MethodSignature := (interfaceName, listIterator1ShortSignature).


    Definition subListShortSignature : ShortMethodSignature := METHODSIGNATURE.Build_t
      (34%positive)
      ((PrimitiveType INT)::(PrimitiveType INT)::nil)
      (Some (ReferenceType (InterfaceType java_util_List_interfaceName)))
    .
    Definition subListSignature : MethodSignature := (interfaceName, subListShortSignature).


    Definition sizeMethod : Method := METHOD.Build_t
      sizeShortSignature
      None
      false
      false
      false
      Public
    .

    Definition isEmptyMethod : Method := METHOD.Build_t
      isEmptyShortSignature
      None
      false
      false
      false
      Public
    .

    Definition containsMethod : Method := METHOD.Build_t
      containsShortSignature
      None
      false
      false
      false
      Public
    .

    Definition iteratorMethod : Method := METHOD.Build_t
      iteratorShortSignature
      None
      false
      false
      false
      Public
    .

    Definition toArrayMethod : Method := METHOD.Build_t
      toArrayShortSignature
      None
      false
      false
      false
      Public
    .

    Definition toArray1Method : Method := METHOD.Build_t
      toArray1ShortSignature
      None
      false
      false
      false
      Public
    .

    Definition add1Method : Method := METHOD.Build_t
      add1ShortSignature
      None
      false
      false
      false
      Public
    .

    Definition remove1Method : Method := METHOD.Build_t
      remove1ShortSignature
      None
      false
      false
      false
      Public
    .

    Definition containsAllMethod : Method := METHOD.Build_t
      containsAllShortSignature
      None
      false
      false
      false
      Public
    .

    Definition addAllMethod : Method := METHOD.Build_t
      addAllShortSignature
      None
      false
      false
      false
      Public
    .

    Definition addAll1Method : Method := METHOD.Build_t
      addAll1ShortSignature
      None
      false
      false
      false
      Public
    .

    Definition removeAllMethod : Method := METHOD.Build_t
      removeAllShortSignature
      None
      false
      false
      false
      Public
    .

    Definition retainAllMethod : Method := METHOD.Build_t
      retainAllShortSignature
      None
      false
      false
      false
      Public
    .

    Definition clearMethod : Method := METHOD.Build_t
      clearShortSignature
      None
      false
      false
      false
      Public
    .

    Definition equalsMethod : Method := METHOD.Build_t
      equalsShortSignature
      None
      false
      false
      false
      Public
    .

    Definition hashCodeMethod : Method := METHOD.Build_t
      hashCodeShortSignature
      None
      false
      false
      false
      Public
    .

    Definition getMethod : Method := METHOD.Build_t
      getShortSignature
      None
      false
      false
      false
      Public
    .

    Definition set1Method : Method := METHOD.Build_t
      set1ShortSignature
      None
      false
      false
      false
      Public
    .

    Definition add2Method : Method := METHOD.Build_t
      add2ShortSignature
      None
      false
      false
      false
      Public
    .

    Definition remove2Method : Method := METHOD.Build_t
      remove2ShortSignature
      None
      false
      false
      false
      Public
    .

    Definition indexOfMethod : Method := METHOD.Build_t
      indexOfShortSignature
      None
      false
      false
      false
      Public
    .

    Definition lastIndexOfMethod : Method := METHOD.Build_t
      lastIndexOfShortSignature
      None
      false
      false
      false
      Public
    .

    Definition listIteratorMethod : Method := METHOD.Build_t
      listIteratorShortSignature
      None
      false
      false
      false
      Public
    .

    Definition listIterator1Method : Method := METHOD.Build_t
      listIterator1ShortSignature
      None
      false
      false
      false
      Public
    .

    Definition subListMethod : Method := METHOD.Build_t
      subListShortSignature
      None
      false
      false
      false
      Public
    .

    Definition interface : Interface := INTERFACE.Build_t
      interfaceName
      (java_util_Collection_interfaceName ::nil)
      nil
      (sizeMethod :: isEmptyMethod :: containsMethod :: iteratorMethod :: toArrayMethod :: toArray1Method :: add1Method :: remove1Method :: containsAllMethod :: addAllMethod :: addAll1Method :: removeAllMethod :: retainAllMethod :: clearMethod :: equalsMethod :: hashCodeMethod :: getMethod :: set1Method :: add2Method :: remove2Method :: indexOfMethod :: lastIndexOfMethod :: listIteratorMethod :: listIterator1Method :: subListMethod :: nil)
      false
      true
      true
    .

  End java_util_List.

  Definition AllClasses : list Class :=  nil.

  Definition AllInterfaces : list Interface := java_util_Iterator.interface :: java_util_ListIterator.interface :: java_lang_Iterable.interface :: java_util_Collection.interface :: java_util_List.interface ::  nil.

  Definition program : Program := PROG.Build_t
    AllClasses
    AllInterfaces
  .

End TheProgram.

