Add LoadPath "../Bicolano".

Require Export ImplemDomain.
Require Export ImplemProgramWithMap.
Require Export BinArray.
Require Export SWP.

Module MDom := ImplemDomain.Make P.

Module MBigStep := BigStep.MakeBigStep MDom.

Module PCM := BinNatMap.

Module MethodSign_Hash.
  Definition t := P.MethodSignature.

  Definition eq_t (x y : t) := 
    let (cx,sx) := x in 
    let (cy,sy) := y in 
    if P.eqClassName cx cy then P.METHODSIGNATURE.eq_t sx sy 
    else false.

  Lemma eq_t_spec : forall t1 t2, if eq_t t1 t2 then t1 = t2 else t1 <> t2.
  Proof.
   intros (cx,sx) (cy,sy); simpl;intros.
   generalize (P.eqClassName_spec cx cy);destruct (P.eqClassName cx cy);intros;subst.
   generalize (P.METHODSIGNATURE.eq_t_spec sx sy); 
      destruct (P.METHODSIGNATURE.eq_t sx sy);intros;subst;trivial.
   intros Heq;injection Heq;intros;auto.
   intros Heq;injection Heq;intros;auto.
  Qed.

  Lemma eq_dec : forall x y:t, x=y \/ ~x=y.
  Proof.
    exact (Aeq_dec _ eq_t eq_t_spec).
  Qed.

  Definition key :=  P.ShortMethodName.
  Definition hash (x:t) := P.METHODSIGNATURE.name (snd x).
End MethodSign_Hash.

Module MMb := MapHash_Base MethodSign_Hash BinMap.
Module MM := Map_Of_MapBase MMb.

Module R <:RULES := BaseLogic2.Rules MBigStep MM PCM.

Module Mwp := SWp R.

