Add LoadPath "../Bicolano".

Require Import ImplemProgramWithList.

Import P.

Module TheProgram.

  Definition java_langPackageName := 2%positive.

  Module java_lang_Object.

    Definition className : ClassName := ( java_langPackageName, 11%positive). 


    Definition finalizeSignature : MethodSignature := METHODSIGNATURE.Build_t
        (className, 10%positive)
                nil
                (ReferenceType (ClassType void))
    .

    Definition getClassSignature : MethodSignature := METHODSIGNATURE.Build_t
        (className, 11%positive)
                nil
                (ReferenceType (ClassType java_lang_Class)
    .

    Definition hashCodeSignature : MethodSignature := METHODSIGNATURE.Build_t
        (className, 12%positive)
                nil
                (ReferenceType (ClassType int)
    .

    Definition notifySignature : MethodSignature := METHODSIGNATURE.Build_t
        (className, 13%positive)
                nil
                (ReferenceType (ClassType void)
    .

    Definition notifyAllSignature : MethodSignature := METHODSIGNATURE.Build_t
        (className, 14%positive)
                nil
                (ReferenceType (ClassType void)
    .

    Definition waitSignature : MethodSignature := METHODSIGNATURE.Build_t
        (className, 15%positive)
                ((PrimitiveType INT)::          ((ReferenceType (ClassType int)::nil)
                (ReferenceType (ClassType void)
    .

    Definition equalsSignature : MethodSignature := METHODSIGNATURE.Build_t
        (className, 16%positive)
                ((ReferenceType (ClassType java_lang_Object)::nil)
                (PrimitiveType BOOLEAN)
    .

    Definition _init_Signature : MethodSignature := METHODSIGNATURE.Build_t
        (className, 17%positive)
                nil
                (ReferenceType (ClassType void)
    .

    Definition toStringSignature : MethodSignature := METHODSIGNATURE.Build_t
        (className, 18%positive)
                nil
                (ReferenceType (ClassType java_lang_String)
    .

    Definition waitSignature : MethodSignature := METHODSIGNATURE.Build_t
        (className, 19%positive)
                nil
                (ReferenceType (ClassType void)
    .

    Definition waitSignature : MethodSignature := METHODSIGNATURE.Build_t
        (className, 20%positive)
                ((PrimitiveType INT)::nil)
                (ReferenceType (ClassType void)
    .

    Definition cloneSignature : MethodSignature := METHODSIGNATURE.Build_t
        (className, 21%positive)
                nil
                (ReferenceType (ClassType java_lang_Object)
    .

    Definition sync_initSignature : MethodSignature := METHODSIGNATURE.Build_t
        (className, 22%positive)
                nil
                (ReferenceType (ClassType void)
    .

    Definition throwNoSuchMethodErrorSignature : MethodSignature := METHODSIGNATURE.Build_t
        (className, 23%positive)
                nil
                (ReferenceType (ClassType void)
    .

    Definition finalizeInstructions : list (PC*Instruction) :=
        (0%N, Return)::
        nil
    .

    Definition finalizeBody : BytecodeMethod := Build_BytecodeMethod_
                                (java_lang_Throwable::nil)
                1
                0
    .

    Definition finalizeMethod : Method := METHOD.Build_t
        finalizeSignature
        (finalizeBody)
        false
        false
        Protected

    .

    Definition getClassInstructions : list (PC*Instruction) :=
    .

    Definition getClassBody : BytecodeMethod := Build_BytecodeMethod_
                nil
                0
                0
    .

    Definition getClassMethod : Method := METHOD.Build_t
        getClassSignature
        (getClassBody)
        true
        false
        Public

    .

    Definition hashCodeInstructions : list (PC*Instruction) :=
    .

    Definition hashCodeBody : BytecodeMethod := Build_BytecodeMethod_
                nil
                0
                0
    .

    Definition hashCodeMethod : Method := METHOD.Build_t
        hashCodeSignature
        (hashCodeBody)
        false
        false
        Public

    .

    Definition notifyInstructions : list (PC*Instruction) :=
    .

    Definition notifyBody : BytecodeMethod := Build_BytecodeMethod_
                nil
                0
                0
    .

    Definition notifyMethod : Method := METHOD.Build_t
        notifySignature
        (notifyBody)
        true
        false
        Public

    .

    Definition notifyAllInstructions : list (PC*Instruction) :=
    .

    Definition notifyAllBody : BytecodeMethod := Build_BytecodeMethod_
                nil
                0
                0
    .

    Definition notifyAllMethod : Method := METHOD.Build_t
        notifyAllSignature
        (notifyAllBody)
        true
        false
        Public

    .

    Definition waitInstructions : list (PC*Instruction) :=
    .

    Definition waitBody : BytecodeMethod := Build_BytecodeMethod_
                                (java_lang_InterruptedException::nil)
                0
                0
    .

    Definition waitMethod : Method := METHOD.Build_t
        waitSignature
        (waitBody)
        true
        false
        Public

    .

    Definition equalsInstructions : list (PC*Instruction) :=
        (0%N, Aload 0%N)::
        (1%N, Aload 1%N)::
        (2%N, If_acmp NeRef 7%N)::
        (5%N, Const INT 1)::
        (6%N, Goto 4%N)::
        (9%N, Const INT 0)::
        (10%N, Ireturn)::
        nil
    .

    Definition equalsBody : BytecodeMethod := Build_BytecodeMethod_
                nil
                2
                2
    .

    Definition equalsMethod : Method := METHOD.Build_t
        equalsSignature
        (equalsBody)
        false
        false
        Public

    .

    Definition _init_Instructions : list (PC*Instruction) :=
        (0%N, Return)::
        nil
    .

    Definition _init_Body : BytecodeMethod := Build_BytecodeMethod_
                nil
                1
                0
    .

    Definition _init_Method : Method := METHOD.Build_t
        _init_Signature
        (_init_Body)
        false
        false
        Public

    .

    Definition toStringInstructions : list (PC*Instruction) :=
        (0%N, New)::
        (3%N, Dup)::
        (4%N, Invokespecial)::
        (7%N, Aload 0%N)::
        (8%N, Invokevirtual)::
        (11%N, Invokevirtual)::
        (14%N, Invokevirtual)::
        (17%N, Nop (* bipush *))::
        (19%N, Invokevirtual)::
        (22%N, Aload 0%N)::
        (23%N, Invokevirtual)::
        (26%N, Invokestatic)::
        (29%N, Invokevirtual)::
        (32%N, Invokevirtual)::
        (35%N, Areturn)::
        nil
    .

    Definition toStringBody : BytecodeMethod := Build_BytecodeMethod_
                nil
                1
                2
    .

    Definition toStringMethod : Method := METHOD.Build_t
        toStringSignature
        (toStringBody)
        false
        false
        Public

    .

    Definition waitInstructions : list (PC*Instruction) :=
        (0%N, Aload 0%N)::
        (1%N, Nop (* lconst_0 *))::
        (2%N, Const INT 0)::
        (3%N, Invokevirtual)::
        (6%N, Return)::
        nil
    .

    Definition waitBody : BytecodeMethod := Build_BytecodeMethod_
                                (java_lang_InterruptedException::nil)
                1
                4
    .

    Definition waitMethod : Method := METHOD.Build_t
        waitSignature
        (waitBody)
        true
        false
        Public

    .

    Definition waitInstructions : list (PC*Instruction) :=
        (0%N, Aload 0%N)::
        (1%N, Nop (* lload_1 *))::
        (2%N, Const INT 0)::
        (3%N, Invokevirtual)::
        (6%N, Return)::
        nil
    .

    Definition waitBody : BytecodeMethod := Build_BytecodeMethod_
                                (java_lang_InterruptedException::nil)
                3
                4
    .

    Definition waitMethod : Method := METHOD.Build_t
        waitSignature
        (waitBody)
        true
        false
        Public

    .

    Definition cloneInstructions : list (PC*Instruction) :=
    .

    Definition cloneBody : BytecodeMethod := Build_BytecodeMethod_
                                (java_lang_CloneNotSupportedException::nil)
                0
                0
    .

    Definition cloneMethod : Method := METHOD.Build_t
        cloneSignature
        (cloneBody)
        false
        false
        Protected

    .

    Definition sync_initInstructions : list (PC*Instruction) :=
    .

    Definition sync_initBody : BytecodeMethod := Build_BytecodeMethod_
                nil
                0
                0
    .

    Definition sync_initMethod : Method := METHOD.Build_t
        sync_initSignature
        (sync_initBody)
        true
        false
        Private

    .

    Definition throwNoSuchMethodErrorInstructions : list (PC*Instruction) :=
        (0%N, New)::
        (3%N, Dup)::
        (4%N, New)::
        (7%N, Dup)::
        (8%N, Ldc)::
        (10%N, Invokespecial)::
        (13%N, Aload 0%N)::
        (14%N, Invokevirtual)::
        (17%N, Invokevirtual)::
        (20%N, Invokevirtual)::
        (23%N, Invokespecial)::
        (26%N, Athrow)::
        nil
    .

    Definition throwNoSuchMethodErrorBody : BytecodeMethod := Build_BytecodeMethod_
                nil
                1
                5
    .

    Definition throwNoSuchMethodErrorMethod : Method := METHOD.Build_t
        throwNoSuchMethodErrorSignature
        (throwNoSuchMethodErrorBody)
        false
        false

    .

            Definition class : Class := CLASS.Build_t
                className
                None
                nil
                nil
                (finalize::getClass::hashCode::notify::notifyAll::wait::equals::_init_::toString::wait::wait::clone::sync_init::throwNoSuchMethodError::nil)
                false
                true
                false
    .

  End java_lang_Object.

  Definition EmptyPackageName := 2%positive.

  Module Bill.

    Definition className : ClassName := (  Definition EmptyPackageName := 2%positive., 11%positive). 

    Definition sumFieldSignature : FieldSignature := FIELDSIGNATURE.Build_t 
      (className, 100%positive)
      (PrimitiveType (ReferenceType (ClassType int))
      .

    Definition sumField : Field := FIELD.Build_t
      sumFieldSignature
      false
      false
      Private
      FIELD.UNDEF
      .

    Definition _init_Signature : MethodSignature := METHODSIGNATURE.Build_t
        (className, 10%positive)
                nil
                (ReferenceType (ClassType void)
    .

    Definition round_costSignature : MethodSignature := METHODSIGNATURE.Build_t
        (className, 11%positive)
                ((ReferenceType (ClassType int)::nil)
                (ReferenceType (ClassType int)
    .

    Definition produce_billSignature : MethodSignature := METHODSIGNATURE.Build_t
        (className, 12%positive)
                ((ReferenceType (ClassType int)::nil)
                (PrimitiveType BOOLEAN)
    .

    Definition _init_Instructions : list (PC*Instruction) :=
        (0%N, Aload 0%N)::
        (1%N, Invokespecial)::
        (4%N, Return)::
        nil
    .

    Definition _init_Body : BytecodeMethod := Build_BytecodeMethod_
                nil
                1
                1
    .

    Definition _init_Method : Method := METHOD.Build_t
        _init_Signature
        (_init_Body)
        false
        false

    .

    Definition round_costInstructions : list (PC*Instruction) :=
    .

    Definition round_costBody : BytecodeMethod := Build_BytecodeMethod_
                                (java_lang_Exception::nil)
                0
                0
    .

    Definition round_costMethod : Method := METHOD.Build_t
        round_costSignature
        (round_costBody)
        false
        false

    .

    Definition produce_billInstructions : list (PC*Instruction) :=
        (0%N, Const INT 1)::
        (1%N, Istore 2%N)::
        (2%N, Goto 20%N)::
        (5%N, Aload 0%N)::
        (6%N, Aload 0%N)::
        (7%N, Getfield)::
        (10%N, Aload 0%N)::
        (11%N, Iload 2%N)::
        (12%N, Invokevirtual)::
        (15%N, Ibinop AddInt)::
        (16%N, Putfield)::
        (19%N, Iinc 2%N 1%Z)::
        (22%N, Iload 2%N)::
        (23%N, Iload 1%N)::
        (24%N, If_icmp LeInt -19%N)::
        (27%N, Const INT 1)::
        (28%N, Ireturn)::
        (29%N, Astore 3%N)::
        (30%N, Const INT 0)::
        (31%N, Ireturn)::
        nil
    .

    Definition produce_billBody : BytecodeMethod := Build_BytecodeMethod_
                nil
                4
                4
    .

    Definition produce_billMethod : Method := METHOD.Build_t
        produce_billSignature
        (produce_billBody)
        false
        false
        Public

    .

            Definition class : Class := CLASS.Build_t
                className
                None
                nil
                (sum::nil)
                (_init_::round_cost::produce_bill::nil)
                false
                false
                true
    .

  End Bill.

  Definition AllClasses : list Class := java_lang_Object :: Bill.class :: nil.

  Definition AllInterfaces : list Interface := nil.

  Definition program : Program := PROG.Build_t
        AllClasses
        AllInterfaces

End TheProgram.