Require Import Misc.

 Ltac simpl_eq := 
  repeat match goal with
  | [eq1 : ?a = _, eq2 : ?a = _ |- _ ] => 
     rewrite eq1 in eq2;inversion eq2;clear eq2;try subst
  end.

 Ltac inversion_mine H := inversion H; clear H; subst.

 Ltac elimFalse := 
  match goal with
  | [ H : False |- _] => elim H
  | _ => idtac
  end.

 Ltac simplIf :=
  match goal with
  | [H1: if ?t then _ else _, H2: ?t = true |- _ ] =>
       rewrite H2 in H1;simplIf
  | [H1: if ?t then _ else _, H2: ?t = false |- _ ] =>
       rewrite H2 in H1;simplIf
  | [H1: match ?t with Some _ => _ | None => _ end, H2:?t = Some _ |- _ ] =>
       rewrite H2 in H1;simplIf
  | [H1: match ?t with Some _ => _ | None => _ end, H2:?t = None |- _ ] =>
       rewrite H2 in H1;simplIf
  | [H1: match ?t with SomeT _ => _ | NoneT => _ end, H2:?t = SomeT _ |- _ ] =>
       rewrite H2 in H1;simplIf
  | [H1: match ?t with SomeT _ => _ | NoneT => _ end, H2:?t = NoneT _ |- _ ] =>
       rewrite H2 in H1;simplIf
  | _ => idtac
  end.

